%global dh_confdir %{_sysconfdir}/dehydrated

Name:       dehydrated-addons
Version:    1.1.0
Release:    1%{?dist}
Summary:    Addons for the dehydrated ACME client (meta package)
Url:        https://gitlab.com/lcts/dehydrated-addons
License:    MIT
Source0:    https://gitlab.com/lcts/%{name}/-/archive/%{version}/%{name}-%{version}.tar.gz

BuildArch:      noarch
Requires:       dehydrated-systemd = %{version}-%{release}
Requires:       dehydrated-hookrunner = %{version}-%{release}
Requires:       dehydrated-dns-lexicon = %{version}-%{release}

%description
Dehydrated-addons is a meta-package collecting multiple
addons for dehydrated.


%package -n dehydrated-systemd
Summary:        Systemd support for dehydrated cert renewal
BuildArch:      noarch
Requires:       dehydrated
Requires:       bash
Requires:       systemd
%if "0%{?rhel}" >= "8" || 0%{?fedora}
BuildRequires:  systemd-rpm-macros
%else
BuildRequires:  systemd
%endif

%description -n dehydrated-systemd
Dehydrated-systemd contains systemd service and timer units to enable
automatic certificate renewal with dehydrated using systemd

%package -n dehydrated-dns-lexicon
Summary:        Dns-01 challenge hook for dehydrated using lexicon
BuildArch:      noarch
Requires:       dehydrated
Requires:       bash
Requires:       python3-dns-lexicon

%description -n dehydrated-dns-lexicon
Dehydrated-dns-lexicon contains a hook for dehydrated that can
be used to perform DNS-01 challenges using any provider
supported by lexicon.

%package -n dehydrated-hookrunner
Summary:        A proxy hook for dehydrated to allow executing multiple hooks
BuildArch:      noarch
Requires:       dehydrated
Requires:       bash

%description -n dehydrated-hookrunner
Dehydrated-hookrunner provides a hook to dehydrated that in turn
allows the user to trigger multiple hooks in sequence.

%package -n dehydrated-deploy-pki
Summary:        A hook to deploy dehydrated-generated certificates
BuildArch:      noarch
Requires:       dehydrated
Requires:       bash

%description -n dehydrated-deploy-pki
Dehydrated-deploy-pki provides a hook to dehydrated that deploys certificates
to configurable directories & run reload commands for updated certificates.

#-- PREP, BUILD & INSTALL -----------------------------------------------------#
%prep
%autosetup -p1 -n %{name}-%{version}

%build
# nothing to build

%install
# set up directory structure
install -p -d -m 0755 %{buildroot}%{_sysconfdir}/sysconfig/
install -p -d -m 0755 %{buildroot}%{dh_confdir}/conf.d/
install -p -d -m 0755 %{buildroot}%{_unitdir}/

# install upstream files
install -m 0755 dns_lexicon/*.sh %{buildroot}%{dh_confdir}/
install -m 0755 hookrunner/*.sh %{buildroot}%{dh_confdir}/
install -m 0755 deploy_pki/*.sh %{buildroot}%{dh_confdir}/
install -m 0640 dns_lexicon/*.conf %{buildroot}%{dh_confdir}/conf.d/
install -m 0644 hookrunner/*.conf %{buildroot}%{dh_confdir}/conf.d/
install -m 0644 deploy_pki/*.conf %{buildroot}%{dh_confdir}/conf.d/
install -m 0644 systemd/dehydrated-renew.timer %{buildroot}%{_unitdir}/
install -m 0644 systemd/dehydrated-renew.service %{buildroot}%{_unitdir}/
install -m 0644 systemd/dehydrated-renew.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/dehydrated-renew

#-- SCRIPTLETS -----------------------------------------------------------------#
%post
%systemd_post dehydrated-renew.service

%preun
%systemd_preun dehydrated-renew.service

%postun
%systemd_postun_with_restart dehydrated-renew.service

#-- FILES ---------------------------------------------------------------------#
%files
%license LICENSE

%files -n dehydrated-systemd
%doc systemd/*.md
%license LICENSE
%{_unitdir}/dehydrated-renew.service
%{_unitdir}/dehydrated-renew.timer
%config(noreplace) %{_sysconfdir}/sysconfig/dehydrated-renew

%files -n dehydrated-dns-lexicon
%doc dns_lexicon/*.md
%license LICENSE
%attr(0755,root,root) %{dh_confdir}/dns_lexicon.sh
%config(noreplace) %attr(0640,root,root) %{dh_confdir}/conf.d/dns_lexicon.conf

%files -n dehydrated-hookrunner
%doc hookrunner/*.md
%license LICENSE
%attr(0755,root,root) %{dh_confdir}/hookrunner.sh
%config(noreplace) %{dh_confdir}/conf.d/hookrunner.conf

%files -n dehydrated-deploy-pki
%doc deploy_pki/*.md
%license LICENSE
%attr(0755,root,root) %{dh_confdir}/deploy_pki.sh
%config(noreplace) %{dh_confdir}/conf.d/deploy_pki.conf

#-- CHANGELOG -----------------------------------------------------------------#
%changelog
* Thu Aug 27 2020 Christopher Engelhard <ce@lcts.de> 1.1.0-1
- new package built with tito

